/***********************************************************************************************************************
 *
 * forceTen - open source geography
 * ================================
 *
 * Copyright (C) 2007-2010 by Tidalwave s.a.s.
 * Project home page: http://forceten.tidalwave.it
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id$
 *
 **********************************************************************************************************************/
package it.tidalwave.geo.explorer.impl.role;

import javax.annotation.Nonnull;
import javax.inject.Inject;
import javax.inject.Provider;
import org.netbeans.platformx.eventbus.api.EventBus;
import it.tidalwave.geo.geocoding.GeoCoderEntitySet;
import it.tidalwave.geo.explorer.role.SelectionHandler;

/***********************************************************************************************************************
 *
 * The default role of the {@link SelectionHandler} - it publishes a {@link GeoEntitySet} to the {@link EventBus}.
 * 
 * @stereotype Role
 *
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
public final class EventBusSelectionHandler extends SelectionHandler
  {
    @Inject
    public Provider<EventBus> eventBus;

    @Override
    public void handleSelection (@Nonnull final GeoCoderEntitySet geoEntitySet)
      {
        eventBus.get().publish(geoEntitySet);
        eventBus.get().publish(geoEntitySet.getSector());
      }
  }
